#! /usr/bin/env perl
#!/usr/bin/speedy

# ===============================================================
#  TD-Board
#  Web notes  (http://espion.s7.xrea.com/)
#
#  $Id: tdboard.cgi,v 1.13.2.4 2004/02/18 07:05:52 gaba Exp $
# ===============================================================

use strict;
use vars qw($wt $past_wt $admin $Q $I $C $DATA_DIR $mode $lock_file $mobile $dir);
use CGI::Carp qw(fatalsToBrowser);

my($SCRIPT, $DATA, $INIT_DIR, $DIR_PER, $lock_time, $version);

## {ݒ ----------------------------------------------------------
$SCRIPT		= 'tdboard.cgi';	# CGIt@C̖O
$DATA			= 'data';			# f[^t@CۑfBNg
$INIT_DIR	= 'init';			# ݒt@CۑfBNg
$DIR_PER		= 0755;				# fBNgp[~bV
$version		= '2.07';			# o[W

# bNXgbvb
# 2`5炢͈̔͂łΉłƎv܂
$lock_time      = 4;

# ݒ͈ȏ
# ====================================================================

$ENV{'TZ'} = 'JST-9';

# ϐ
$wt = $past_wt = $admin = $mode = $mobile = $Q = $I = $C = "";
$DATA_DIR = $lock_file = $dir = "";
$Q = decode();
$C = get_cookie();
make_trip();

load_init();
mobile_check();

$dir = ($I->{'data_dir'}) ? $I->{'data_dir'} : "d_$Q->{d}";
$DATA_DIR = "${DATA}/${dir}";
make_dir() unless(-e $DATA_DIR);
$mode = $Q->{m};

file_lock();
if($Q->{write}) {
	if(post_check(1)) {
		preview();
	} else {
		write_msg();
	}
} elsif($Q->{prev}) {
	post_check(0);
	preview();
	set_cookie();
} elsif($Q->{del}) {
	$mode='res';
	del_msg();
	view();
} elsif($mode eq 's') {
	search_view();
} elsif($mode eq 'p') {
	past();
} elsif($mode eq 'r') {
	print_html_write_form(1);
	$I->{'tag_title'} = '';
} elsif($Q->{no}) {
	$mode = 'res' if($mode eq '');
	view();
} elsif($mode eq 'h') {
	print_html_help();
} elsif($mode eq 'w') {
	print_html_write_form(2);
	$I->{'tag_title'} = 'Xbh쐬';
} else {
	top();
}

print_html_header();
print_html_link();
print '<hr size="1" class="line">';
print_html_footer();
out($wt);


## lock --------------------------------------------------------------
sub file_lock {
	my $file = "./${DATA_DIR}/lock/lockfile";

	for (my $i = 0; $i < $lock_time; $i++, sleep 1) {
		return if(rename($file, $lock_file = $file . time));
	}

	opendir(DIR, "./${DATA_DIR}/lock/");
	foreach (readdir(DIR)) {
		if (/^${file}(\d+)/) {
			if(time - $1 > 60 and rename("./${DATA_DIR}/lock/${_}", $lock_file = $file . time)) {
				closedir(DIR);
				return;
			}
			last;
		}
	}
	closedir(DIR);
	error();
}

## unlock ------------------------------------------------------------
sub unlock {
	rename($lock_file, "./${DATA_DIR}/lock/lockfile");
}

## init t@Cǂݍ ---------------------------------------------
sub load_init {
	my $init = "./${INIT_DIR}/init_$Q->{d}.cgi";

	unless(-e $init) {
		$init = "./${INIT_DIR}/init_.cgi";
		$Q->{d} = '';
	}

	do($init);
	$I = init();
	$I->{'tag_title'} = 'gbv';
	$Q->{sage} = 1 if($I->{'sage'});
}

## gђ[`FbN --------------------------------------------------
sub mobile_check {
	my $agent = $ENV{'HTTP_USER_AGENT'};
	if($agent =~ /(DoCoMo|J-PHONE|UP\.Browser|DDIPOCKET|ASTEL|PDXGW|Palmscape|Xiino|sharp pda browser|Windows CE|L-mode|w3m)/i) {
		$mobile = 1;
		$I->{'top_thread'} = 0;
	}
}

## fR[h ----------------------------------------------------------
sub decode {
	my(%query, $buffer, $i);
	my $method = $ENV{'REQUEST_METHOD'};
	$method = '' unless($method);

	if ($method eq "POST") {
		return if($ENV{'CONTENT_LENGTH'} > 50000);
		read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
	} else {
		$buffer = $ENV{'QUERY_STRING'};
	}
	$buffer = '' unless($buffer);

	foreach(split(/&/, $buffer)) {
		my ($name, $value) = split(/=/);
		$value =~ tr/+/ /;
		$value =~ s/%([0-9A-Fa-f][0-9A-Fa-f])/pack("H2", $1)/eg;
		$value =~ s/&/&amp;/g;
		$value =~ s/</&lt;/g;
		$value =~ s/>/&gt;/g;
		$value =~ s/"/&quot;/g;
		$value =~ s/,/&#44;/g;
		$value =~ s/\x0D\x0A/<BR>/g;
		$value =~ s/\x0D/<BR>/g;
		$value =~ s/\x0A/<BR>/g;
		$query{$name} = $value;
		last if($i > 100 and $i++);
	}

	$query{url} =~ s/^http\:\/\///;
	$query{d}   =~ s/\///g;
	$query{no}  =~ tr/0-9//dc;
	$query{nm}  =~ tr/0-9//dc;
	$query{v}   =~ tr/0-9//dc;

	return \%query;
}

## Cookie ۑ -------------------------------------------------------
sub set_cookie {
	my($sec,$min,$hour,$mday,$mon,$year,$wday) = gmtime(time + 60*24*60*60);
	my $expire = sprintf("%s, %02d-%s-%04d %02d:%02d:%02d GMT\n",
					('Sunday','Monday','Tuesday','Wednesday','Thursday','Friday','Saturday')[$wday],
					$mday,
					('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec')[$mon],
					$year+1900, $hour, $min, $sec
				);

	my $cook = "$C->{name}\,$C->{mail}\,$C->{key}\,$C->{color}\,$C->{url}";
	$cook =~ s/\;/\&\\/g;
	print "Set-Cookie: TDBOARD$Q->{d}=$cook; expires=$expire";
}

## Cookie 擾 -------------------------------------------------------
sub get_cookie {
	my %cook;
	my $cookie = $ENV{HTTP_COOKIE};
	$cookie = '' unless($cookie);

	foreach(split(/\s*;\s*/, $cookie))  {
		my($nm, $val) = split(/=/);
		if($nm eq "TDBOARD$Q->{d}") {
			$val =~ s/&\\/;/g;
			($cook{name},$cook{mail},$cook{key},$cook{color},$cook{url}) = split(/,/, $val);
			last;
		}
	}

	if($Q->{prev} or $Q->{write}) {
		$cook{name}  = $Q->{name};
		$cook{mail}  = $Q->{mail};
		$cook{key}   = $Q->{key};
		$cook{color} = $Q->{color};
		$cook{url}   = $Q->{url};
	}

	$cook{name}  = '' unless($cook{name});
	$cook{mail}  = '' unless($cook{mail});
	$cook{key}   = '' unless($cook{key});
	$cook{url}   = '' unless($cook{url});
	$cook{color} = "#000000" unless($cook{color});

	return \%cook;
}

## gbv ------------------------------------------------------
sub make_trip {
	$Q->{name} =~ s///;
	$Q->{trip} = '';

	if($Q->{name} =~ /(#|)(.*)$/) {
		my $salt = substr($2,1,2);
		$Q->{trip} = crypt($2, $salt);
		$Q->{trip} = substr($Q->{trip},5,8);
		$Q->{trip} = ''.$Q->{trip};
		$Q->{name} =~ s/(#|)(.*)$//;
	}
}

## bZ[WH ----------------------------------------------------
sub make_msg {
	my $url;
	$Q->{msg} =~ s/(<BR>){4,}/<BR><BR><BR>/g;
	$Q->{msg} =~ s/([^=^\"]|^)(http\:[\w\.\~\-\/\?\&\+\=\:\@\%\;\#]+)/$url=cut_text($2,96);
	"$1<a href='$2' target='_top'>$url<\/a>"/eg;
	$Q->{msg} =~ s/&#44;/,/g;
	$Q->{msg} =~ s/\[i\](.+)\[\/i\]/<em>$1<\/em>/g;
	$Q->{msg} =~ s/\[b\](.+)\[\/b\]/<strong>$1<\/strong>/g;
	$Q->{msg} =~ s/\[u\](.+)\[\/u\]/<u>$1<\/u>/g;
	$Q->{msg} =~ s/\[s([1-7])\](.+)\[\/s\]/<font size="$1">$2<\/font>/g;
	$Q->{msg} =~ s/\[c=(\S+)\](.+)\[\/c\]/<font color="$1">$2<\/font>/g;
	$Q->{msg} =~ s/\[#([\d]+)\]/\[<a href="${SCRIPT}?d=$Q->{d}&amp;no=${1}">#$1<\/a>\]/g;
	$Q->{msg} =~ s/(&gt;)+([\d]+)/<a href="${SCRIPT}?d=$Q->{d}&amp;no=$Q->{no}&amp;v=${2}#${2}">&#62;$2<\/a>/g;
	$Q->{msg} =~ s/,/&#44;/g;
}

## bZ[Wݗ쐬 ------------------------------------------
sub decode_msg {
	my $host = $ENV{'REMOTE_HOST'};
	my $addr = $ENV{'REMOTE_ADDR'};
	$addr = '' unless($addr);
	$host = $addr unless($host);
	make_msg();

	return ','.get_time(time()).','.$Q->{name}.','.$Q->{msg}.','.$Q->{mail}.
			','.$Q->{url}.','.$Q->{color}.','.crypt($Q->{key},'pa').','.$Q->{trip}.','.$host.",\n";
}

## GMT -----------------------------------------------------------
sub get_time {
	my $time = $_[0];
	return '- - -' if($time == 0);

	my $date;
	my($sec,$min,$hour,$day,$mon,$year,$wday) = localtime($time);
	$year += 1900;
	$mon++;
	if($_[1]) {
		$date = sprintf("%02d/%02d %02d:%02d", $mon,$day,$hour,$min);
	} else {
		$date = sprintf("%04d/%02d/%02d(%s) %02d:%02d:%02d",
					$year,$mon,$day,('','','','','','','y')[$wday],$hour,$min,$sec);
	}
	return $date;
}

## ؂l ------------------------------------------------------
sub cut_text {
	my($s, $c) = @_;
	if(length($s) <= $c) {
		return $s;
	} else {
		return substr($s,0,($c-2)) . '...';
	}
}

## f[^fBNg쐬 --------------------------------------------
sub make_dir {
	print_html_error('f[^fBNg쐬܂B');

	mkdir("./${DATA_DIR}/", $DIR_PER);
	mkdir("./${DATA_DIR}/old/", $DIR_PER);
	mkdir("./${DATA_DIR}/lock/", $DIR_PER);

	open(OT,">./${DATA_DIR}/lock/lockfile");
	close(OT);

	open(OT,">./${DATA_DIR}/nm.dat");
	print OT '0';
	close(OT);

	open(OT,">./${DATA_DIR}/list.dat");
	close(OT);
}

## N --------------------------------------------------------
sub auto_href {
	my($no, $ttl, $md, $add) = @_;
	$no  = "&amp;no=${no}" if($no);
	$md  = "&amp;m=${md}"  if($md);
	$add = "&amp;${add}"   if($add);
	return "<a href='${SCRIPT}?d=$Q->{d}${md}${no}${add}'>${ttl}</a>@";
}

## [hʏ Xbhꗗn ---------------------------------------
sub top {
	my $i = 0;
	my @view_list;

	print_html_thread_list_header();
	open(IN, "${DATA_DIR}/list.dat");
	while(my $dat = <IN>) {
		$i++;
		my $no = print_html_thread_data($dat, $i);
		push(@view_list, $no) if($i <= $I->{'top_thread'});
		last if($mode eq '' and $i >= $I->{'max_thread_list'});
	}
	close(IN);
	print_html_thread_list_footer();

	if($mode) {
		$I->{'tag_title'} = 'SXbh';
	} else {
		unless($mobile) {
			$wt .= '<hr class="sep">';
			print_html_write_form(2);
			$wt .= '<hr class="sep">';
		}
		foreach (@view_list) {
			$Q->{no} = $_;
			view();
			$wt .= '<hr class="sep">';
		}
	}
}

## [hʏ ߋOꗗ -----------------------------------------
sub past {
	my $nm_file = "./${DATA_DIR}/nm.dat";
	open(IN, $nm_file) or error();
	my $nm = int(<IN>);
	close(IN);
	$nm -= $I->{'max_thread'};
	$nm = (int($nm/$I->{'past_max_thread'})+1) if($nm > 0);

	$past_wt .= 'ߋOړ' if($nm > 0);

	for(1..$nm) {
		my $i = $nm - $_ + 1;
		$past_wt .= ($Q->{nm} == $i or (!$Q->{nm} and $nm == $i)) ?  " [${i}]" :
		" <a href='${SCRIPT}?d=$Q->{d}&amp;m=p&amp;nm=${i}'>[${i}]</a>";
	}

	$nm = $Q->{nm} if($Q->{nm});

	my $past_list = "./${DATA_DIR}/old/list${nm}.cgi";
	if(open(IN, $past_list)) {
		my $i;
		print_html_thread_list_header();
		while(my $dat = <IN>) {
			$i++;
			print_html_thread_data($dat, $i);
		}
		print_html_thread_list_footer();
	} else {
		print_html_error('܂B');
	}

	$I->{'tag_title'} = 'ߋO';
}

## [hʏ Xbh\ -----------------------------------------
sub view {
	my($i, $old_mode, $max_view);
	my $file = "./${DATA_DIR}/$Q->{no}.cgi";

	unless(open(IN, $file)) {
		$file = "./${DATA_DIR}/old/$Q->{no}.cgi";
		if(open(IN, $file)) {
			$mode = 'p';
		} else {
			print_html_error('Xbht܂');
			return ;
		}
		$past_wt = auto_href('', 'ߋOꗗ', 'p');
	}

	if($mode) {
		$max_view = ($mode eq 'res') ?  $I->{'max_msg_view2'} : $I->{'max_res'};

		if($Q->{del_no} == 0 and $Q->{del_key} eq $I->{'admin_pass'}) {
			$max_view = $I->{'max_res'};
			$admin = 1;
		}
	} else {
		$max_view = $I->{'max_msg_view'};
	}

	my $top = <IN>;
	my $count = print_html_thread_header($top);
	while(<IN>) {
		$i++;
		if($mode eq 'res' and $Q->{v}) {
			if($i > 1 and $Q->{v} > $i) {
				$wt .= "<hr size='1'>" if($i == 2);
				next;
			}
		} elsif($max_view > 0 and $count - $max_view >= $i and $i > 1) {
			$wt .= "<hr size='1'>" if($i == 2);
			next;
		}
		print_html_thread_body($_, $i);
	}

	print_html_write_form(0) unless($mode);

	if($mode and $mode ne "p") {
		if($mobile) {
			$wt .= "</div>";
		} else {
			print_html_write_form(1);
		}
		print_html_delete_form();
		print_html_thread_footer();
	} else {
		print_html_thread_footer(1);
	}
}

##  --------------------------------------------------------------
sub search_view {
	my $nm_file = "./${DATA_DIR}/nm.dat";
	open(IN, $nm_file) or error();
	my $nm = int(<IN>);
	close(IN);
	$nm -= $I->{'max_thread'};
	$nm = (int($nm/$I->{'past_max_thread'})+1) if($nm > 0);

	print_html_search_form($nm);

	if($Q->{text}) {
		my $search_name = $Q->{text};
		$search_name =~ s/@/ /g;
		$search_name =~ s/\t/ /g;
		my @pairs = split(/ /,$search_name);
		my $s_count = 0;
		my $max_search = ($mobile) ? 20 : 50;
		my $wt_tmp = $wt;
		$wt = '';

		my $list = ($Q->{past} == 0) ? "./${DATA_DIR}/list.dat" : "./${DATA_DIR}/old/list".$Q->{past}.".cgi";
		my $dir =  ($Q->{past} == 0) ? "./${DATA_DIR}/" : "./${DATA_DIR}/old/";

		open(IN, $list) or error();
		while (<IN>) {
			my($no,$count,$title,$fname,$name,$time) = split(/,/);
			my $dat = "$no,$count,$title,$fname,$name,$time";
			my($i,$flag) = (0,0);
			open(INS, $dir.$no.".cgi");
			<INS>;
			foreach my $val (<INS>) {
				$i++;
				next if($val =~ /^1,/);
				my $vflag = 0;
				foreach (@pairs) {
					if(index($val,$_) == -1) {
						$vflag = 1;
						last;
					}
				}
				unless($vflag) {
					print_html_thread_header($dat) if($flag == 0);
					print_html_thread_body($val, $i);
					$flag++; $s_count++;
					last if($s_count == $max_search);
				}
			}
			print_html_thread_footer(1) if($flag);

			close(INS);
			last if($s_count == $max_search);
		}
		close(IN);
		$wt_tmp .= "<h2><div class='caption'>${s_count}qbg</div></h2>";
		$wt = $wt_tmp . $wt;
	}

	$I->{'tag_title'} = '';
}

## ̓`FbN ------------------------------------------------------
sub post_check {
	my($flag, $count);
	my $md = shift;

	if($Q->{no} eq '' and $Q->{title} eq '') {
		print_html_error('薼͂Ă܂');
		$flag = 1;
	}
	if($Q->{name} eq '') {
		print_html_error('O͂Ă܂');
		$flag = 1;
	}
	if($Q->{msg} eq '') {
		print_html_error('bZ[W͂Ă܂');
		$flag = 1;
	}

	if(50 <= ($count = $Q->{msg} =~ tr/<BR>/<BR>/) / 4) {
		print_html_error('s߂ł');
		$flag = 1;
	} elsif(length($Q->{msg}) >= ($count/8+1) * 160) {
		print_html_error('sƂ܂');
		$flag = 1;
	}

	if(!$flag and $md and $I->{'ip_time'}) {
		my(@old_ip, $ip_flag);
		my $ip = $ENV{'REMOTE_ADDR'};
		my $file = "./${DATA_DIR}/ip.dat";

		open(IPIN, $file);
		foreach(0..$I->{'ip_count'}) {
			$old_ip[$_] = <IPIN>;
			chomp($old_ip[$_]);
			$ip_flag ++ if($old_ip[$_] eq $ip);
		}
		close(IPIN);

		if(time() < (stat($file))[9] + $I->{'ip_time'} ** $ip_flag) {
			print_html_error('Ae͏܂ĉ');
			$flag = 1;
		} else {
			open(IPOT, ">${file}");
			print IPOT $ip . "\n";
			foreach(@old_ip) {
				print IPOT;
				print IPOT "\n";
			}
			close(IPOT);
		}
	}

	$mode = 'writing';
	return $flag;
}

## [hʏ ݃vr[ -----------------------------------
sub preview {
	my $time = get_time(time);
	$Q->{msg2} = $Q->{msg};
	$Q->{msg2} =~ s/<BR>/\r\n/g;

	make_msg();

	my $data = ",$time,$Q->{name},$Q->{msg},$C->{mail},$C->{url},$C->{color},,$Q->{trip},";
	print_html_preview($data);

	if($Q->{no}) {
		print_html_write_form(1);
	} else {
		print_html_write_form(3);
	}
	$wt .= '</div>';
}

## ݐU蕪 --------------------------------------------------
sub write_msg {
	if($Q->{no}) {
		return if(res_msg());
	} else {
		return if(new_msg());
	}

	set_cookie();
	print_html_redirect();
}

## VX쐬 --------------------------------------------------------
sub new_msg {
	my($file, $past);
	my $nm_file = "./${DATA_DIR}/nm.dat";

	if($I->{'max_res'} == 0) {
		print_html_error('ȏXbh͗Ă܂');
		return 1;
	}

	open(OIN, "+<${nm_file}");
	$Q->{no} = int(<OIN>);
	$Q->{no}++;
	seek(OIN,0,0);
	print OIN $Q->{no};
	close(OIN);

	$file = "./${DATA_DIR}/$Q->{no}.cgi";
	open(OT, ">${file}");
	print OT "$Q->{no},1,$Q->{title},$Q->{name} $Q->{trip},\n";
	print OT decode_msg();
	close(OT);

	$I->{'max_thread'} --;
	$file = "./${DATA_DIR}/list.dat";
	open(IN, "<${file}");
	open(OT, ">${file}.bak");
	print OT "$Q->{no},1,$Q->{title},$Q->{name} $Q->{trip},$Q->{name} $Q->{trip},".time().",\n";
	for(1..$I->{'max_thread'}) {
		my $ot = <IN>;
		$ot = '' unless($ot);
		print OT $ot;
	}
	close(OT);
	my $past = <IN>;
	close(IN);

	if($past) {
		my($no, $dum) = split(/,/, $past);
		my $nm = $Q->{no} - $I->{'max_thread'} - 1;
		my $nmfile = "./${DATA_DIR}/old/list".(int($nm/$I->{'past_max_thread'}) + 1).".cgi";
		open(NMB, "<${nmfile}");
		open(NM, ">${nmfile}.bak");
		print NM $past;
		foreach(<NMB>) {
			print NM;
		}
		close(NM);
		close(NMB);
		rename("${nmfile}.bak", $nmfile);
		rename("./${DATA_DIR}/${no}.cgi", "./${DATA_DIR}/old/${no}.cgi");
	}

	rename("${file}.bak", $file);

	return 0;
}

## X --------------------------------------------------------------
sub res_msg {
	my $file   = "./${DATA_DIR}/$Q->{no}.cgi";
	my $l_file = "./${DATA_DIR}/list.dat";

	unless(open(IN, $file)) {
		print_html_error('Xbht܂');
		return 1;
	}

	my $top = <IN>;
	my($no, $count, $title, $name) = split(/,/, $top);

	if($count >= $I->{'max_res'}) {
		print_html_error('ȏԐML͏߂܂');
		close(IN);
		return 1;
	}

	$count++;
	open(OT, ">${file}.bak");
	print OT "${no},${count},${title},${name},\n";
	foreach (<IN>) {
		print OT;
	}
	print OT decode_msg();
	close(OT);
	close(IN);

	my $line = "${no},${count},${title},${name},$Q->{name} $Q->{trip},".time().",\n";
	open(IN, $l_file) or error();
	open(OT, ">${l_file}.bak");
	print OT $line unless($Q->{sage});
	foreach (<IN>) {
		if(index($_, "${no},") == 0) {
			print OT $line if($Q->{sage});
		} else {
			print OT;
		}
	}
	close(OT);
	close(IN);

	rename("${file}.bak", $file);
	rename("${l_file}.bak", $l_file);

	return 0;
}

## 폜 --------------------------------------------------------------
sub del_msg {
	my $file = "./${DATA_DIR}/$Q->{no}.cgi";

	unless(open(IN, $file)) {
		print_html_error('Xbht܂');
		return;
	}

	my $top   = <IN>;
	my @lines = <IN>;
	close(IN);

	return unless($Q->{del_no});

	my $line = $lines[$Q->{del_no}-1];
	return unless($line);

	my($dm1,$dm2,$dm3,$dm4,$dm5,$dm6,$dm7,$pass) = split(/,/, $line);

	if($pass eq crypt('', 'pa') and $Q->{del_key} ne $I->{'admin_pass'}) {
		print_html_error('폜L[ݒ肳Ă܂');
		return;
	} elsif($pass eq crypt($Q->{del_key}, 'pa') or $Q->{del_key} eq $I->{'admin_pass'}) {
		$lines[$Q->{del_no}-1] = "1${line}";
		open(OT, ">${file}.bak");
		print OT $top;
		print OT @lines;
		close(OT);
		rename("${file}.bak", $file);
	} else {
		print_html_error('폜L[Ⴂ܂');
		return;
	}

	print_html_redirect();
}

################################################################################

## o --------------------------------------------------------------
sub out {
	print STDOUT ($_[0]);
	unlock();
	exit(0);
}

## HTML wb_[ -----------------------------------------------------
sub print_html_header {
	print "Content-type: text/html\r\n\r\n";
	print <<_HTML_;
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html lang='ja'>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=Shift_JIS">
<meta name="generator" content="TD-Board ${version}">
<link rel="stylesheet" href="./theme/base.css" type="text/css">
<link rel="stylesheet" href="./theme/$I->{'css'}.css" type="text/css">
<title>$I->{'title'} - $I->{'tag_title'}</title>
</head>
<body>
<div class="adminmenu">
<span class="adminmenu"><a href="$I->{'top_page'}">z[</a></span>
<span class="adminmenu"><a href="${SCRIPT}?d=$Q->{d}&amp;m=h">g</a></span>
</div>
<h1><a name="top">$I->{'title'}</a></h1>
<hr size='1' class='line'>
_HTML_
}

## HTML tb^[ -----------------------------------------------------
sub print_html_footer {
	$wt .= <<_HTML_;
<hr size='1' class='line'>
<div class='footer'>
Generated by <a href="http://espion.s7.xrea.com/">TD-Board</a> version ${version}
</div>
</body>
</html>
_HTML_
}

## HTML wb_Atb^N -----------------------------------------
sub print_html_link {
	# 㕔
	print "<div class='calendar'>\n";
	print "<div class='year'>\n";
	if($mode) {
		print auto_href('', 'Xbhꗗ') . "@";
		if($mode eq 'res' or $mode eq 'all') {
			if($mobile) {
				print auto_href($Q->{no}, '', 'r');
			} else {
				print "<a href='#Res'></a>@";
			}
			print auto_href($Q->{no}, 'ŐV'.$I->{'max_msg_view2'}.'');
			if($mode eq 'res') {
				print auto_href($Q->{no}, 'Sĕ\', 'all');
			}
		} elsif($mode eq 'p') {
			print $past_wt;
		} elsif($mode eq 'writing' or $mode eq 's' or $mode eq 'h' or $mode eq 'w' or $mode eq 'r') {
		} else {
			print auto_href($Q->{no}, 'XV', $mode);
		}
	} else {
		if($mobile) {
			print auto_href('', 'Xbh쐬', 'w');
		} else {
			print "<a href='#Write'>Xbh쐬</a>@@";
		}
		print auto_href('', 'SXbh', 'l');
		print auto_href('', '', 's');
		print auto_href('', 'ߋO', 'p');
		print auto_href('', 'XV');
	}
	print "</div>\n";
	print "</div>\n";

	unless($mobile) {
		# 
		$wt .= "<div class='calendar'>\n";
		$wt .= "<div class='year'>\n";
		if($mode) {
			$wt .= auto_href('', 'Xbhꗗ'). "@";
			if($mode eq 'res' or $mode eq 'all') {
				$wt .= "<a href='#top'>gbv</a>@";
				$wt .= auto_href($Q->{no}, 'ŐV'.$I->{'max_msg_view2'}.'');
				if($mode eq 'res') {
					$wt .= auto_href($Q->{no}, 'Sĕ\', 'all');
				}
			}
		} else {
			$wt .= "<a href='#top'>gbv</a>@@";
			$wt .= auto_href('', 'SXbh', 'l');
			$wt .= auto_href('', '', 's');
			$wt .= auto_href('', 'ߋO', 'p');
			$wt .= auto_href('', 'XV');
		}
		$wt .= "</div>";
		$wt .= "</div>";
	}
}

## HTML Xbhꗗ̃wb_[ ---------------------------------------
sub print_html_thread_list_header {
	$wt .= "<div class='day'> ";
	$wt .= ($mode ne 'p') ? $I->{'header_msg'} : '@';
	$wt .= "<div class='body'>";
	$wt .= "<div class='caption'>";
	$wt .= ($mode ne 'p') ? 'Xbhꗗ' : 'ߋOꗗ';
	$wt .= "</div>";

	if($mobile) {
		$wt .= '<p> </p>';
	} else {
		$wt .= <<_HTML_;
<table summary='Xbhꗗ' class='thread_list'>
<tr class='tr_header'>
<th class='th_header'>No.</th>
<th class='th_header'>薼</th>
<th class='th_header'>e</th>
<th class='th_header'>e</th>
<th class='th_header'>ŏIe</th>
<th class='th_header'>ŏIe</th>
</tr>
_HTML_
	}
}

## HTML Xbhꗗ̃tb^[ ---------------------------------------
sub print_html_thread_list_footer {
	$wt .= "</table>\n" unless($mobile);
	$wt .= "</div>\n";
	$wt .= "</div>\n";
}

## HTML Xbhꗗ̃C -----------------------------------------
sub print_html_thread_data {
	my($no, $count, $title, $fname, $name, $time) = split(/,/, shift);
	my $i = shift;
	$title = cut_text($title, 34);
	$title = ($i <= $I->{'top_thread'} and $mode eq '') ? "<a href='#${no}'>${title}</a>" : auto_href($no, $title);
	$title .= $I->{'new_msg'} if(time() - $time < $I->{'new_time'}*3600);

	if($mobile) {
		$time = get_time($time, 1);
		$wt .= " ${title}<BR>\n";
		$wt .= "${time} (${count})<BR>\n";
	} else {
		$time = get_time($time);
		$fname = cut_text($fname, 26);
		$name  = cut_text($name, 26);
		$wt .= <<_HTML_;
<tr>
<td class='td_body'>y${no}z</td>
<td class='td_body'>${title}</td>
<th class='td_body'>${count}</th>
<td class='td_body'>${fname}</td>
<td class='td_body'>${name}</td>
<td class='td_body'>${time}</td>
</tr>
_HTML_
	}

	return $no;
}

## HTML Xbhwb_[ ---------------------------------------------
sub print_html_thread_header {
	my($no, $count, $title, $name) = split(/,/, shift);
	$wt .= "<div class='day'><a name='$no'></a>\n";

	if($mode eq '' or $mode eq "s") {
		$wt .= "<a href='#top'>gbv</a>@ ";
		$wt .= auto_href($no, 'ŐV'.$I->{'max_msg_view2'}.'');
		$wt .= auto_href($no, 'Sĕ\', 'all');
	}
	$wt .= "<h2><span class='title'>y${no}z ${title}</span></h2>\n";
	$wt .= "<div class='body'>";

	$I->{'tag_title'} = $title if($mode);
	return $count;
}

## HTML Xbhtb^[ ---------------------------------------------
sub print_html_thread_footer {
	my $mode = shift;
	$wt .= "</div>";
	$wt .= "</div>" if($mode);
}

## HTML Xbh 1X -----------------------------------------------
sub print_html_thread_body {
	my($flag, $time, $name, $msg, $mail, $url, $color, $pass, $trip, $ip) = split(/,/, shift);
	my $i = shift;

	if($flag and !$admin) {
		$name = $msg = "폜";
		$trip = $mail = $color = '';
		$time = "---";
	}

	$ip   = ($admin) ? "($ip)" : '';
	$mail = "@<a href='mailto:${mail}'>Mail</a>" if($mail);
	$url  = "@<a href='http://${url}'>Home</a>"  if($url);
	$i = "<a name='${i}'>${i}</a>" if($mode);

	$wt .= <<_HTML_;
${i}: <span class='commentator'>${name} ${trip}:</span> <span class='commenttime'>${time} ${mail} ${url} ${ip}</span>
<div class="section">
<p><font color='$color'>${msg}</font></p>
</div>
_HTML_
}

## HTML ݃tH[ ---------------------------------------------
sub print_html_write_form {
	my($checked, $form_msg, $form_msg2);
	my $md = shift;
	my $row = ($md) ? "7" : "4";

	if($md == 2) {
		$wt .= "<a name='Write'></a>";
		$wt .= "<div class='day'>";
		$form_msg = "쐬";
		$form_msg2 = 'VKXbh쐬';
	} elsif($md == 3) {
		$wt .= "</div>";
		$form_msg = "쐬";
		$form_msg2 = 'VKXbh쐬';
	} else {
		$wt .= "</div>";
		$wt .= "<a name='Res'></a>";
		$form_msg = "ԐM";
		$form_msg2 = '';
	}
	$wt .= "<div class='form'>\n";
	$wt .= "<div class='caption'>${form_msg2}</div>\n";
	$checked = " checked" if($Q->{sage} == 1);

	$wt .= <<_HTML_;
<form action='${SCRIPT}' method='post' class='comment'>
<input type='hidden' name='d' value='$Q->{d}'>
<input type='hidden' name='no' value='$Q->{no}'>
O: <input type='text' name='name' value='$C->{name}' size='20' class='field'>@
Mail: <input type='text' name='mail' value='$C->{mail}' size='20' class='field'>@
_HTML_
	$wt .= "Sage:<input type='checkbox' name='sage' value='1'${checked}>" if($md < 2 and $I->{'sage'} != 1);
	$wt .= "<BR>";

	if($md >= 2) {
		$wt .= <<_HTML_;
薼: <input type='text' name='title' value='$Q->{title}' size='60' class='field'>
<br>
_HTML_
	}

	$wt .= <<_HTML_;
URL&nbsp;: <input type='text' name='url' value='http://$C->{url}' size='60' class='field'>
<BR>
_HTML_
	$wt .= "bZ[W:<BR>" if($md);
	$wt .= <<_HTML_;
<textarea name='msg' rows='${row}' cols='60' class='field'>$Q->{msg2}</textarea><BR>
<input type='submit' name='write' value='${form_msg}' class='field'>@
<input type='submit' name='prev' value='vr[' class='field'>@
폜L[<input type='password' name='key' value='$C->{key}' size='5' class='field'>(L폜Ɏgp)
<BR>
_HTML_
	foreach my $color (@{$I->{'colors'}}) {
		my $s;
		$s = ' checked' if($C->{color} eq $color);
		$wt .= "<input type='radio' name='color' value='${color}'${s}>";
		$wt .= "<font color='${color}'></font>";
	}
	$wt .= <<_HTML_;
</form>
_HTML_

	$wt .= "</div>";
	if($md >= 2) {
		$wt .= "</div>\n";
		$wt .= "</div>\n";
	}
}

## HTML 폜tH[ -------------------------------------------------
sub print_html_delete_form {
	$wt .= <<_HTML_;
<div class='form'>
<form action='${SCRIPT}' method='post' class='comment'>
<input type='hidden' name='d' value='$Q->{d}'>
<input type='hidden' name='no' value='$Q->{no}'>
No.<input type='text' size='4' name='del_no' class='field' value=''>
폜L[<input type='password' size='4' name='del_key' class='field' value=''>@
<input type='submit' name='del' value='L폜' class='field'>
</form>
</div>
_HTML_
}

## HTML tH[ -------------------------------------------------
sub print_html_search_form {
	my $nm = shift;
    $wt .= <<_HTML_;
<div class='day'>
<h2><span class='title'></span></h2>
<div class='form'>
<p>
<form action='$SCRIPT' method='post' class='comment'>
<select name='past'>
<option value='0'>sO
_HTML_

    for(1..$nm) {
        my $i = $nm - $_ + 1;
        my $s = ($Q->{past} eq $i) ? ' selected' : '';
        $wt .= "<option value='${i}'${s}>ߋO${i}\n";
    }
    $wt .= <<_HTML_;
</select>
<input type='hidden' name='m' value='s'>
<input type='hidden' name='d' VALUE='$Q->{d}'>
<input type=text name='text' size='24' value='$Q->{text}'>@
<input type=submit value=''>
</form>
</p>
</div>
</div>
_HTML_
}

## HTML ݃vr[ -------------------------------------------
sub print_html_preview {
	my $data = shift;
	$wt .= "<h2><span class='title'>݃vr[</span></h2>";
	$wt .= "<div class='day'>\n";
	if($Q->{no}) {
		$wt .= "<div class='form'>\n";
	} else {
		$wt .= "<h2><span class='title'>y1z $Q->{title}</span></h2>\n";
		$wt .= "<div class='body'>\n";
	}
	print_html_thread_body($data, 0);
	#$wt .= '</div>';
}

## HTML ݊ナ_CNg -----------------------------------
sub print_html_redirect {
	my $link = auto_href($Q->{no}, 'Click here!');
	print "Content-type: text/html\r\n\r\n";
	print <<_HTML_;
<html>
<head>
<meta http-equiv='refresh' content='0;url=${SCRIPT}?d=$Q->{d}&amp;no=$Q->{no}'>
<title>moving</title>
</head>
<body>
${link}
</body>
</html>
_HTML_
	unlock();
	exit;
}

## HTML G[bZ[W ---------------------------------------------
sub print_html_error {
	my $msg = shift;
	$wt .= "<div class='caption'>G[: ${msg}</div>\n";
}

## HTML wv -------------------------------------------------------
sub print_html_help {
	$I->{'tag_title'} = 'wv';

	my $sage_msg = "<li>XĹA{Iɏɏオł".
			"<strong>sagẽ`FbN{bNXɃ`FbNĂƏオ܂B</strong><p> </p>"
			unless($I->{'sage'});

	$wt .= <<_HTML_;
<div class='day'>
<h2><span class='title'>wv</span></h2>
<div class='body'>
<ul>
	<li><strong>Xbht[g^</strong>̌fłB
	<p> </p>
	${sage_msg}
	<li>eeɂ́A<strong>^O͈؎gpo܂񂪁A<a href='#tag'>Ǝ^O</a>gpo܂B</strong>
	<p> </p>
	<li>eeURLꍇ́AŃN܂B 
	<p> </p>
	<li>1̃Xbhɑ΂ő僌X́A<strong>$I->{'max_res'}</strong>܂łƂȂĂ܂B
	<p> </p>
	<li>Xbh<strong>$I->{'max_thread'}</strong>𒴂ƁAÂXbh珇ԂɉߋOƂȂ܂B
	<p> </p>
	<li><B>$I->{'new_time'}</B>ȓ̋Lɂ́u$I->{'new_msg'}v܂B
	<p> </p>
	<li>gbvg܂BO<B>u#Dȕv(:O#pass)</B>邾łB
	<p> </p>
	<li>폜L[ݒ肵Ă΁A̓ee폜o܂B<BR>
	폜́uX\\vʂ̈ԉɂ܂B
	<p> </p>
	<LI>Ǘ҂svƔfL⑼l排L͗\\Ȃ폜邱Ƃ܂B 
</ul>
</div>
</div>
<div class='day'>
<a name='tag'><h2><span class='title'>Ǝ^O</span></h2></a>
<div class='body'>
<ul>
	<li><strong>Ǝ^O</strong>̐łB
	<p> </p>
	Ǝ^OƂ́AHTML^O̕ω̂łB<BR>
	ɓee𑕏邽߂Ɏgp܂B<BR>
	ɏĂȊÕ^O<strong>gpo܂</strong>̂łӉB
	<p> </p>
	ɏĂQlɂď݂Ă݂ĉB<BR>
	EɏĂ镗ɕ\\͂łB
	<p> </p>
	<li>[i]ΐ[/i]  <em>ΐ</em>
	<p> </p>
	<li>[b][/b]  <strong></strong>
	<p> </p>
	<li>[u][/u]  <u></u>
	<p> </p>
	<li>[s1][/s]  <font size='1'></FONT>
	<p> </p>
	<li>[s5]傫[/s]  <font size='5'>傫</FONT>@is1`s7܂Ŏw肷鎖\\łj
	<p> </p>
	<li>[c=red]ԐF[/c]  <font color='red'>ԐF</FONT>
	<p> </p>
	<li>[c=666666]DF[/c]  <font color='#666666'>DF</font>@i16iA͐Fw肷鎖ɂς܂j
	<p> </p>
	<li>[u][c=green][/c][/u]  <u><font color='green'></font></u>
	<p> </p>
	Ō̂悤ɁAgݍ킹Ďg\\łB
	<p> </p>
	܂ALɃN𒣂鎖o܂B
	<p> </p>
	<li>[#2]  XbhNo.2ɃN
	<p> </p>
	<li>&gt;5  ̃Xbh5Ԗڂ̃X\\
	<p> </p>
	킩Ȃ΁A≺B
	<p> </p>
</ul>
</div>
</div>
_HTML_

}

## f[^t@C֘ÃG[ ----------------------------------------
sub error {
	$wt .= <<_HTML_;
<a href='./${SCRIPT}?d=$Q->{d}'>Xbhꗗ</A>@@
<font color='#ED0008' size='+1'>f[^t@CĂ\\܂</FONT>
_HTML_

	print_html_header(1);
	print_html_footer();
	out($wt);
}

